//
//  TwitterTrends.m
//  Weather
//
//  Created by Alasdair Allan on 30/08/2009.
//  Copyright 2009 __MyCompanyName__. All rights reserved.
//

#import "WeatherAppDelegate.h"
#import "MainViewController.h"
#import "FindNearbyPlace.h"
#import "JSON/JSON.h"

@implementation FindNearbyPlace

- (void)queryServiceWithLat:(NSString *)latitude andLong:(NSString *)longtidue {
	
	appDelegate = (WeatherAppDelegate *)[[UIApplication sharedApplication] delegate];
	responseData = [[NSMutableData data] retain];
	
	NSString *url = [NSString stringWithFormat:@"http://ws.geonames.org/findNearbyPlaceNameJSON?lat=%@&lng=%@", latitude, longtidue];	
	theURL = [[NSURL URLWithString:url] retain];
	NSURLRequest *request = [NSURLRequest requestWithURL:theURL];
	[[NSURLConnection alloc] initWithRequest:request delegate:self];
	
}


- (NSURLRequest *)connection:(NSURLConnection *)connection willSendRequest:(NSURLRequest *)request redirectResponse:(NSURLResponse *)redirectResponse {
	[theURL autorelease];
	theURL = [[request URL] retain];
	return request;
}

- (void)connection:(NSURLConnection *)connection didReceiveResponse:(NSURLResponse *)response {
	[responseData setLength:0];
}
	 
- (void)connection:(NSURLConnection *)connection didReceiveData:(NSData *)data {
	[responseData appendData:data];
}
	 
- (void)connection:(NSURLConnection *)connection didFailWithError:(NSError *)error {
	// Handle Error
}
	 
- (void)connectionDidFinishLoading:(NSURLConnection *)connection {
	
	NSString *content = [[NSString alloc] initWithBytes:[responseData bytes] length:[responseData length] encoding:NSUTF8StringEncoding];
	NSLog(@"Content = %@", content);
	
	SBJSON *parser = [[SBJSON alloc] init];
	NSDictionary *json = [parser objectWithString:content];
	NSArray *geonames = [json objectForKey:@"geonames"];
	
	NSString *city = [[NSString alloc] init];
	NSString *state = [[NSString alloc] init];
	NSString *country = [[NSString alloc] init];
	for (NSDictionary *name in geonames) {
		city = [name objectForKey:@"name"];
		state = [name objectForKey:@"adminCode1"];
		country = [name objectForKey:@"countryName"];
	}
	[parser release];
	
	NSLog( @"Location = %@, %@, %@", city, state, country );

	NSString *string = [NSString stringWithFormat:@"%@,%@", city, state];
	appDelegate.mainViewController.location = string;
	[appDelegate.mainViewController.loadingActivityIndicator stopAnimating];
	[appDelegate.mainViewController refreshView: self];

}

	 
-(void)dealloc {
	[appDelegate release];
	[responseData release];
	[theURL release];
	[super dealloc];
}

@end
