//
//  WhereAmIAppDelegate.m
//  WhereAmI
//
//  Created by Alasdair Allan on 02/10/2009.
//  Copyright __MyCompanyName__ 2009. All rights reserved.
//

#import "WhereAmIAppDelegate.h"
#import "WhereAmIViewController.h"

@implementation WhereAmIAppDelegate

@synthesize window;
@synthesize locationManager;
@synthesize viewController;


- (void)applicationDidFinishLaunching:(UIApplication *)application {    

    
	self.locationManager = [[[CLLocationManager alloc] init] autorelease];
		//	if ( self.locationManager.locationServicesEnabled ) {
	if ( [CLLocationManager locationServicesEnabled] ) {
		NSLog( @"Starting CLLocationManager" );
		self.locationManager.delegate = self;
		self.locationManager.distanceFilter = 1000;
	    [self.locationManager startUpdatingLocation];
	}
	
    // Override point for customization after app launch    
    [window addSubview:viewController.view];
    [window makeKeyAndVisible];
}


- (void)dealloc {
    [viewController release];
    [window release];
    [super dealloc];
}

#pragma mark CLLocationManagerDelegate Methods

- (void)locationManager:(CLLocationManager *)manager didUpdateToLocation:(CLLocation *)newLocation fromLocation:(CLLocation *)oldLocation {
	
	NSLog( @"new location = %@", [newLocation description] );
	MKCoordinateSpan span;
	span.latitudeDelta = 0.2;
	span.longitudeDelta = 0.2;
	 
	MKCoordinateRegion region;
	region.span = span;
	region.center = newLocation.coordinate;
	
	[viewController.mapView setRegion:region animated:YES];
	viewController.mapView.showsUserLocation = YES;
	viewController.latitude.text = [NSString stringWithFormat:@"%f", newLocation.coordinate.latitude];
	viewController.longitude.text = [NSString stringWithFormat:@"%f", newLocation.coordinate.longitude];
	
}


@end
