//
//  CityGuideViewController.m
//  CityGuide
//
//  Created by Alasdair Allan on 07/08/2009.
//  Copyright __MyCompanyName__ 2009. All rights reserved.
//

#import "RootController.h"
#import "CityGuideDelegate.h"
#import "CityController.h"
#import "AddCityController.h"
#import "City.h"

@implementation RootController

@synthesize tableView;

#pragma mark Instance Methods

- (void)addCity:(id)sender {
	AddCityController *addCity = [[AddCityController alloc] init];
	[self presentModalViewController:addCity animated:YES];
	[addCity release];
}

#pragma mark UIViewController Methods

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidLoad {
	self.title = @"City Guide";
	self.navigationItem.rightBarButtonItem = [[UIBarButtonItem alloc] initWithBarButtonSystemItem:UIBarButtonSystemItemAdd target:self action:@selector(addCity:)];
	
	CityGuideDelegate *delegate = (CityGuideDelegate *)[[UIApplication sharedApplication] delegate];
	cities = delegate.cities;
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}

- (void)dealloc {
	[tableView release];
	[cities release];
    [super dealloc];
}

#pragma mark UITableViewDataSource Methods

- (UITableViewCell *)tableView:(UITableView *)tv cellForRowAtIndexPath:(NSIndexPath *)indexPath {
	UITableViewCell *cell = [tv dequeueReusableCellWithIdentifier:@"cell"];
	if( nil == cell ) {
		cell = [[[UITableViewCell alloc] initWithFrame:CGRectZero reuseIdentifier:@"cell"] autorelease];
	}
	
	if (indexPath.row < cities.count ) {
		City *thisCity = [cities objectAtIndex:indexPath.row];
		cell.textLabel.text = thisCity.cityName;
		cell.textLabel.textColor = [UIColor blackColor];
		cell.editingAccessoryType = UITableViewCellAccessoryNone;

 	} else {
		cell.textLabel.text = @"Add New City...";
		cell.textLabel.textColor = [UIColor lightGrayColor];
		cell.editingAccessoryType = UITableViewCellAccessoryDisclosureIndicator;
	}
	return cell;
}

- (NSInteger)tableView:(UITableView *)tv numberOfRowsInSection:(NSInteger)section {
	NSInteger count = cities.count;
	return count;
}


#pragma mark UITableViewDelegate Methods

- (void)tableView:(UITableView *)tv didSelectRowAtIndexPath:(NSIndexPath *)indexPath {	
	CityGuideDelegate *delegate = (CityGuideDelegate *)[[UIApplication sharedApplication] delegate];

	if (indexPath.row < cities.count ) {

		CityController *city = [[CityController alloc] initWithIndexPath:indexPath];
		[delegate.navController pushViewController:city animated:YES];
		[city release];
	}
	[tv deselectRowAtIndexPath:indexPath animated:YES];
}

@end
